# Banner Administration System v 1.0.6
# 
# --------------------------------------------------------
#
# Table structure for table 'banners_ban'
#

DROP TABLE IF EXISTS banners_ban;
CREATE TABLE banners_ban (
   id_ban bigint(20) NOT NULL auto_increment,
   idbty_ban bigint(20),
   idcli_ban bigint(20),
   banner_ban varchar(255),
   index_ban varchar(255) DEFAULT '',
   hits_ban bigint(20) DEFAULT '0' NOT NULL,
   PRIMARY KEY (id_ban),
   KEY idx_ban_1 (idcli_ban),
   KEY idx_ban_2 (idbty_ban)
);


# --------------------------------------------------------
#
# Table structure for table 'banners_bty'
#

DROP TABLE IF EXISTS banners_bty;
CREATE TABLE banners_bty (
   id_bty bigint(20) NOT NULL auto_increment,
   typename_bty varchar(40),
   width_bty int(11),
   height_bty int(11),
   PRIMARY KEY (id_bty)
);


# --------------------------------------------------------
#
# Table structure for table 'banners_cli'
#

DROP TABLE IF EXISTS banners_cli;
CREATE TABLE banners_cli (
   id_cli bigint(20) NOT NULL auto_increment,
   client_cli varchar(100),
   address1_cli varchar(100),
   address2_cli varchar(100),
   tel_cli varchar(20),
   fax_cli varchar(20),
   email_cli varchar(255),
   web_cli varchar(255),
   company_cli varchar(100),
   PRIMARY KEY (id_cli)
);


# --------------------------------------------------------
#
# Table structure for table 'banners_pag'
#

DROP TABLE IF EXISTS banners_pag;
CREATE TABLE banners_pag (
   id_pag bigint(20) NOT NULL auto_increment,
   page_pag varchar(255),
   PRIMARY KEY (id_pag)
);


# --------------------------------------------------------
#
# Table structure for table 'banners_pos'
#

DROP TABLE IF EXISTS banners_pos;
CREATE TABLE banners_pos (
   id_pos bigint(20) NOT NULL auto_increment,
   idpag_pos bigint(20) DEFAULT '0' NOT NULL,
   position_pos bigint(20) DEFAULT '0' NOT NULL,
   idbty_pos bigint(20) DEFAULT '0' NOT NULL,
   iddban_pos tinyint(4) DEFAULT '0' NOT NULL,
   PRIMARY KEY (id_pos),
   UNIQUE banner_pos_idx_1 (idpag_pos, position_pos),
   UNIQUE id_pos (id_pos),
   KEY id_pos_2 (id_pos, idpag_pos, position_pos, idbty_pos, iddban_pos)
);


# --------------------------------------------------------
#
# Table structure for table 'banners_rst'
#

DROP TABLE IF EXISTS banners_rst;
CREATE TABLE banners_rst (
   id_rst bigint(20) NOT NULL auto_increment,
   idban_rst bigint(20),
   idpag_rst bigint(20),
   position_rst bigint(20),
   view_rst bigint(20),
   initview_rst bigint(20) DEFAULT '0',
   lifetime_rst bigint(20) DEFAULT '0',
   PRIMARY KEY (id_rst),
   KEY idx_rst_1 (idban_rst),
   KEY idx_rst_2 (idpag_rst, position_rst)
);


# --------------------------------------------------------
#
# Table structure for table 'banners_usr'
#

DROP TABLE IF EXISTS banners_usr;
CREATE TABLE banners_usr (
   id_usr bigint(20) NOT NULL auto_increment,
   name_usr varchar(40),
   passwd_usr varchar(40) DEFAULT '',
   level_usr varchar(40),
   PRIMARY KEY (id_usr)
);
                                                                                                     
INSERT INTO banners_usr (name_usr, passwd_usr, level_usr) VALUES ('admin', 'admin', 'Administrator');